import com.intelligt.modbus.jlibmodbus.Modbus;
import com.intelligt.modbus.jlibmodbus.ModbusSlave;
import com.intelligt.modbus.jlibmodbus.ModbusSlaveFactory;
import com.intelligt.modbus.jlibmodbus.data.DataHolder;
import com.intelligt.modbus.jlibmodbus.data.ModbusHoldingRegisters;
import com.intelligt.modbus.jlibmodbus.exception.ModbusIOException;
import com.intelligt.modbus.jlibmodbus.serial.*;
import jssc.SerialPortList;

import java.io.Console;

public class MainSlave {

    static public void main(String[] arg) {
        SerialParameters sp = new SerialParameters();
        Modbus.setLogLevel(Modbus.LogLevel.LEVEL_DEBUG);

        try {
            String[] dev_list = SerialPortList.getPortNames();
            System.out.println("Доступные порты:");

            for (int n = 0; n < dev_list.length; n++) {
                System.out.println(dev_list[n]);
            }

            if (dev_list.length > 0) {
                sp.setDevice(arg[arg.length - 1]);
                sp.setBaudRate(SerialPort.BaudRate.BAUD_RATE_9600);
                sp.setDataBits(8);
                sp.setParity(SerialPort.Parity.NONE);
                sp.setStopBits(1);


                SerialUtils.setSerialPortFactory(new SerialPortFactoryJSSC());
                ModbusSlave m = ModbusSlaveFactory.createModbusSlaveRTU(sp);

                DataHolder dataHolder = new DataHolder();
                ModbusHoldingRegisters registers = new ModbusHoldingRegisters(10);
                registers.set(0, 101);
                registers.set(1, 105);
                registers.set(2, 660);

                dataHolder.setHoldingRegisters(registers);
                m.setDataHolder(dataHolder);

                try {
                    m.listen();
                    int symbol = 0;
                    while (symbol >= 0) {
                        symbol = System.in.read();
                        if (symbol != 10)
                            registers.set(0, symbol);
                    }

                } catch (ModbusIOException e) {
                    e.printStackTrace();
                } catch (RuntimeException e) {
                    throw e;
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        } catch (RuntimeException e) {
            throw e;
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}